文档章节

Java之异常处理【7】

kongjunli
 kongjunli
发布于 2016/08/13 13:28
字数 740
阅读 3
收藏 0

异常:程序运行期(执行期)出现的错误【不是语法错误】,是java提供的一种用于处理程序错误的机制。如:除0溢出,数组下标溢出、读文件不存在。

Java程序执行过程中如出现异常事件,系统自动的生成异常类对象,封装了异常事件的信息并被提交给Java运行时系统,成为‘’抛异常‘’。

当Java运行时系统收到异常时,会寻找能处理这一异常的代码,并把当前异常交给其处理,称为“捕获异常”。

一、异常分类图

Throwable:父类  Error和Exception是两个子类。其中Error指系统异常,比如虚拟机异常,不需要处理。Exception又分为两种,其中Runtime Exception指经常出现的,比如除0溢出等,可以捕获也可以不捕获。其他的就要求必须要捕获,常见的在jdk中看到方法后面跟了throws就必须catch.

public class TestException{
public static void main(String args[]){
     int a[]={3,2,5};
//捕获异常 
     try{
	System.out.println(a[3]);}
     catch(ArrayIndexOutOfBoundsException e){//e是异常对象,当检测到异常的时候会系统自动初始化,交给Catch的代码处理
	System.out.println("系统正在维护。。。。");
	e.printStackTrace();}//用来跟踪异常事件发生时执行堆栈的内容
}}

 

二、五个关键字

  • try:可能发生异常的语句
  • catch:捕获,并处理异常(printStackTrace()用来跟踪异常事件发生时执行堆栈的内容)
  • throw:方法内部抛异常
  • throws:声明方法异常
  • final:代码中无论是否有异常都会执行,清除资源
public void someMethod()throws someException{
     if(somecondition)
     throw new someException(“错误原因”);
}
try{
someMethod(); //someMethod()方法明确抛异常,所以调用时必须要catch
}
catch(someMethod e)
{
}
try{
}
catch(someException1 e1){
}
try{
}
catch(someException2 e2){
}
finally{
}
执行过程:1.e1->finally
        2.e2->finally
        3.无异常->finally

三、自定义异常类

步骤:

  • 通过继承java.lang.Exception类声明自己的异常类
  • 在方法适当的位置生成自定义异常的实例,并用throw语句抛出
  • 在方法的声明部分用throws语句声明该方法可能抛出的异常
package Exception;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
class MyException extends Exception{
	private int id;
	private String message;
	public MyException(String message,int id){
		super(message);
		this.id=id;
	}
	public int getID(){
		return id;	}
}
public class TestException {
	public void regist(int i) throws MyException{
		if(i<0)
			throw new MyException("人数不合法。。",1);
		else
			System.out.println("num:"+i);
	}
	public void manger(){
		try{regist(-50);}//regist()方法抛异常了,因此必须捕获
		catch(MyException e){
			System.out.println("操作类型:"+e.getID());
			e.printStackTrace();
		}
		System.out.println("操作结束!");
	};
	public static void main(String args[]) 
	{  
		TestException test=new TestException();
		test.manger();
	}
		/*int a[]={3,2,5}; 
		try{
		System.out.println(a[3]);}
		catch(ArrayIndexOutOfBoundsException e){//e是异常对象,当检测到异常的时候会系统自动初始化
			System.out.println("系统正在维护。。。。");
			e.printStackTrace();{}*/
			
	}
结果:操作类型:1
     操作结束!
     Exception.MyException: 人数不合法。。
	at Exception.TestException.regist(TestException.java:19)
	at Exception.TestException.manger(TestException.java:24)
	at Exception.TestException.main(TestException.java:34)

 

© 著作权归作者所有

共有 人打赏支持
kongjunli
粉丝 0
博文 25
码字总数 7291
作品 0
西安
程序员
对JDBC的支持 之 7.1 概述

概述 JDBC回顾 传统应用程序开发中,进行JDBC编程是相当痛苦的,如下所示: //cn.javass.spring.chapter7. TraditionalJdbcTest @Test public void test() throws Exception { Connection co...

heroShane
2014/02/27
0
0
Java学习资料-Java异常处理

4、Java异常处理 4.1 Java异常概念 Java异常是Java提供的用于处理程序中错误的一种机制。 所谓错误是指在程序运行的过程中发生一些异常事件(如:除0溢出,数组下标越界,所要读取的文件不存...

晓阳
2015/01/07
0
0
Java编程基础知识点和技术点归纳

Java是一种可以撰写跨平台应用软件的面向对象的程序设计语言。Java 技术具有卓越的通用性、高效性、平台移植性和安全性,广泛应用于PC、数据中心、游戏控制台、科学超级计算机、移动电话和互...

Java小辰
05/23
0
0
从 java bean 的内省到 dbutils 的应用

java bean 内省的基础 java bean 的内省,其实可以算是反射的一种基础应用,关于 java 的反射,无非就是获得对应的类、属性、方法、修饰符等的应用,对于 java 的反射探讨,可以点击参考 ja...

peiquan
07/04
0
0
图说 Java:理解 Java 机制最受欢迎的 8 幅图

世间总是一图胜过千万言,下面的8幅图来自于 Program Creek 的 Java教程 ,目前这是该网站最受欢迎的文章. 希望本文能帮你回顾你已经知道的那些知识。如果图片讲解的不够清晰,你可能需要阅读详...

大数据之路
2013/10/30
0
3

没有更多内容

加载失败,请刷新页面

加载更多

下一页

Memcached启动参数详解

memcached -d -m 1024 -l 192.168.100.101 -p 11211 -P /tmp/memcached.pid -c 1024 -f 1.25 -n 80 -t 16 运行参数描述 -d:以守护(daemon)进程方式启动; -u:是运行Memcache的用户,例如 ......

月下狼
18分钟前
0
0
xgboost-kaggle

https://www.kaggle.com/dansbecker/xgboost This tutorial is part of the Learn Machine Learning series. In this step, you will learn how to build and optimize models with the powe......

tantexian
18分钟前
0
0
nginx学习八 代理服务

最常用的语法 proxy_pass Syntax: proxy_pass URL;Default: --Context:location.if in location,limit_exception 反向代理 例:/etc/nginx/conf.d/default.conf 反向代理(代理服务端)......

Romanceling
26分钟前
0
0
npm ERR! Unexpected end of JSON ...

npm install 报错: npm ERR! Unexpected end of JSON input while parsing near '..."^2.8.14"},"_hasShrin' npm ERR! A complete log of this run can be found in: ... 打开终端 命令: 第......

大_侠
30分钟前
0
0
Android中的设计模式之责任链模式

参考 《设计模式:可复用面向对象软件的基础 》5.1 Chain of responsibility 职责链 对象行为型模式 《Android源码设计模式解析与实战》第9章 使编程更有灵活性--责任链模式 意图 使多个对象...

newtrek
33分钟前
0
0

没有更多内容

加载失败,请刷新页面

加载更多

下一页

返回顶部
顶部